#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>

#define MAXLEN 1024

/* This code works on Zeus! */
int main()
{
  /* dup2()  makes newfd be the copy of oldfd, 
   * closing newfd first if necessary.
   */

	char data[MAXLEN];
	int fd;
	int errorCode;
	char *errorString;

	fd = open("test.txt", O_WRONLY | O_CREAT | O_TRUNC, S_IRWXU);
	errorCode = dup2(fd, STDOUT_FILENO);
	
	if(errorCode == -1)
	{
		perror("Dup2 error found");
		exit(-1);
	}

	fprintf(stderr,"> ");
	fgets(&(data[0]),MAXLEN,stdin);
	
	errorCode = write(9, &(data[0]), strlen(data)+1);
	if(errorCode == -1)
	{
		errorString = strerror(errno);
		printf("Error: %s\n", errorString);
		exit(-1);
	}
	
	
	printf("%s\n", data);
	
	close(fd);
	
	printf("ONCE MORE: %s\n", data);
}
